Init()
{
	level.bleed = 0;

	if (!level.regen_model)
	{
		if(getCvar("scr_bleeding") == "")
			setCvar("scr_bleeding", 0);
		if( getCvarInt("scr_bleeding") > 0)
			level.bleed = 1;
	}

	level thread onPlayerConnect();
}

onPlayerConnect()
{
	for(;;)
	{
		level waittill("connecting", player);

		player.bleeding = 0;
		player.bleed_count = 0;

		if (level.bleed)
		{
			player thread onPlayerSpawned();
			player thread onPlayerKilled();
			player thread onJoinedTeam();
			player thread onJoinedSpectators();
			player thread onPlayerDisconnect();
		}
	}
}

onJoinedTeam()
{
	self endon("disconnect");
	
	for(;;)
	{
		self waittill("joined_team");
		self notify("end_bleed");
	}
}

onJoinedSpectators()
{
	self endon("disconnect");
	
	for(;;)
	{
		self waittill("joined_spectators");
		self notify("end_bleed");
	}
}

onPlayerSpawned()
{
	self endon("disconnect");
	
	for(;;)
	{
		self waittill("spawned_player");
		self notify("end_bleed");

		self.bleeding = 0;
		self.bleed_count = 0;

		//self thread playerBleed();
	}
}

onPlayerKilled()
{
	self endon("disconnect");
	
	for(;;)
	{
		self waittill("killed_player");
		self notify("end_bleed");

		self.bleeding = 0;
		self.bleed_count = 0;
	}
}

onPlayerDisconnect()
{
	self waittill("disconnect");
	self notify("end_bleed");
}

playerBleed(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime)
{
	self endon("killed_player");

	if (sMeansOfDeath == "MOD_BLEED")
		return;

	// Do not do friendly damage if friendly damage is off
	if(level.gametype != "dm" && isPlayer(eAttacker) && self != eAttacker && self.pers["team"] == eAttacker.pers["team"])
	{
		if(level.friendlyfire == "0" || level.friendlyfire == "2")
			return;
		if(level.friendlyfire == "3")
		{
			iDamage = int(iDamage * .5);
		}
	}

	self notify("end_bleed");
	wait .05;

	self endon("end_bleed");

	old_bleed = 0;

	if ( !isDefined(self.bleeding) )
		self.bleeding = 0;

	if (self.bleeding)
		old_bleed = self.bleeding;

	//Calculate bleed
	bleed = Calculate_Bleed(iDamage, sMeansOfDeath, sWeapon, sHitLoc);

	if (old_bleed > bleed)
		bleed = old_bleed;

	if (!bleed)
		return;

	self.bleeding = bleed;
	old_health = self.health;

	wait 2.5;

	while (self.bleeding)
	{
		if (self.bleeding > 3)
		{
			timer = 2.45;
			loop = 2;
			dam = 2;
		}
		else if (self.bleeding > 2)
		{
			timer = 3.2;
			loop = 3;
			dam = 2;
		}
		else if (self.bleeding > 1)
		{
			timer = 4.0;
			loop = 4;
			dam = 1;
		}
		else
		{
			timer = 5.0;
			loop = 1;
			dam = 0;
		}

		dam = dam + randomint(3) + 1;

		while (loop)
		{
			wait timer;

			if (!self.bleeding)
				return;

			// Healthpack pickup?
			if (self.health > old_health)
			{
				self.bleeding = 0;
				return;
			}
			else
				old_health = self.health;

			self.health = self.health - dam;

			if (self.health < 1)
			{
				self.health = 1;
				self finishPlayerDamage(eInflictor, eAttacker, 2, 0, "MOD_BLEED", sWeapon, undefined, undefined, sHitLoc, psOffsetTime);

			}

			loop--;

			if (self.bleeding > 1)
				self playLocalSound("breathing_hurt");
			else
				self playLocalSound("breathing_better");
		}

		self.bleeding = self.bleeding - 1;
	}
}

Calculate_Bleed(Damage, MeansOfDeath, Weapon, HitLoc)
{
	score = 0;

	//Damage
	if (Damage > 60)
		score = score + 3;
	else if (Damage > 30)
		score = score + 2;
	else if (Damage > 15)
		score = score + 1;

	if (MeansOfDeath == "MOD_FALLING" || MeansOfDeath == "MOD_PISTOL_BULLET")
		score = score - 1;
	else if (MeansOfDeath == "MOD_EXPLOSIVE" || MeansOfDeath == "MOD_GRENADE_SPLASH")
		score = score + 1;

	if (HitLoc == "head" || HitLoc == "neck" || HitLoc == "torso_upper")
		score = score + 1;
	else if (HitLoc == "left_arm_lower" || HitLoc == "left_foot" || HitLoc == "left_leg_lower" || HitLoc == "right_arm_lower" || HitLoc == "right_foot" || HitLoc == "right_leg_lower")
		score = score - 1;

	if (score < 1)
		score = 0;

	return score;
}
