Init()
{
	level.landmines = 0;
	if (getcvar("scr_allow_landmines") != "" && getcvarint("scr_allow_landmines") > 0)
		level.landmines = 1;

	if (level.landmines)
		Setup_Mines();
}

Setup_Mines()
{
	if(!isdefined(game["gamestarted"]))
	{
		// Mine model
		game["mine_model"] = "xmodel/bblandmine";
		precacheModel(game["mine_model"]);

		// HUD Warning
		game["mine_warn"] = &"AA_MI_MINA_01";
		precacheString(game["mine_warn"]);

		// HUD Defuse
		game["mine_defuse"] = &"AA_MI_MINA_02";
		precacheString(game["mine_defuse"]);

		//Mine PLant
		game["mine_plant_txt"] = &"AA_MI_MINA_03";
		precacheString(game["mine_plant_txt"]);

		//Mine Text
		game["mine_txt"] = &"AA_MI_MINA_04";
		precacheString(game["mine_txt"]);

		// HUD Ammo
		game["mine_hud_ammo"] = "gfx/custom/bblandhud2.tga";
		precacheShader(game["mine_hud_ammo"]);
	}

	level.mine_explosion_effect = loadfx ("fx/explosions/grenadeExp_dirt.efx");

	// Land mine limiter
	game["landmines"] = [];
	game["currentmine"] = 0;

	level.landmined_limit = 4;
	if (getcvar("scr_landmines_max") != "")
	{
		if( getcvarint("scr_landmines_max") > 4 && getcvarint("scr_landmines_max") < 33 )
			level.landmined_limit = getcvarint("scr_landmines_max");
		else if( getcvarint("scr_landmines_max") > 32)
			level.landmined_limit = 4;
	}

	level.allow_warning = 0;
	if (getcvar("scr_landmine_warning") != "" && getcvarint("scr_landmine_warning") > 0)
		level.allow_warning = 1;

	level.snipermines = 0;
	if (getcvar("scr_allow_mine_sniper") != "" && getcvarint("scr_allow_mine_sniper") > 0)
		level.snipermines = 1;
	level.boltactionmines = 0;
	if (getcvar("scr_allow_mine_boltaction") != "" && getcvarint("scr_allow_mine_boltaction") > 0)
		level.boltactionmines = 1;
	level.semiautomines = 0;
	if (getcvar("scr_allow_mine_semiauto") != "" && getcvarint("scr_allow_mine_semiauto") > 0)
		level.semiautomines = 1;
	level.smgmines = 0;
	if (getcvar("scr_allow_mine_smg") != "" && getcvarint("scr_allow_mine_smg") > 0)
		level.smgmines = 1;
	level.mgmines = 0;
	if (getcvar("scr_allow_mine_mg") != "" && getcvarint("scr_allow_mine_mg") > 0)
		level.mgmines = 1;
	level.shotgunmines = 0;
	if (getcvar("scr_allow_mine_shotgun") != "" && getcvarint("scr_allow_mine_shotgun") > 0)
		level.shotgunmines = 1;

	level.mine_barsize = 192;

	level.mine_defusetime = 5;
	if (getcvar("scr_landmine_defuse_time") != "")
		level.mine_defusetime = getcvarint("scr_landmine_defuse_time");
	if (level.mine_defusetime < 3)
		level.mine_defusetime = 3;
	if (level.mine_defusetime > 20)
		level.mine_defusetime = 20;

	level.mine_planttime = 5;
	if (getcvar("scr_landmine_plant_time") != "")
		level.mine_planttime = getcvarint("scr_landmine_plant_time");
	if (level.mine_planttime < 3)
		level.mine_planttime = 3;
	if (level.mine_planttime > 20)
		level.mine_planttime = 20;

	level.mine_difficulty = 2;
	if (getcvar("scr_landmine_depth") != "" && getcvarint("scr_landmine_depth") < 2)
		level.mine_difficulty = 1;

	level.mine_trip_distance = 30;
	level.mine_defuse_distance = 45;
	level.mine_warn_distance = 100;

	level thread onPlayerConnect();
}

onPlayerConnect()
{
	for(;;)
	{
		level waittill("connecting", player);

		player thread onPlayerSpawned();
		player thread onPlayerKilled();
	}
}

onPlayerKilled()
{
	self endon("disconnect");

	for(;;)
	{
		self waittill("killed_player");
		wait .05;

		// Clear HUD elements
		if (isDefined(self.mine_hud_warn))
			self.mine_hud_warn destroy();
		if (isDefined(self.mine_hud_def_warn))
			self.mine_hud_def_warn destroy();
		if (isDefined(self.mine_hud_ammo))
			self.mine_hud_ammo destroy();
		if (isDefined(self.mine_hud_ammotxt))
			self.mine_hud_ammotxt destroy();
		if (isDefined(self.mine_plant_txt))
			self.mine_plant_txt destroy();
		if (isDefined(self.mine_plant_progressbackground))
			self.mine_plant_progressbackground destroy();
		if (isDefined(self.mine_plant_progressbar))
			self.mine_plant_progressbar destroy();
	}
}

onPlayerSpawned()
{
	self endon("disconnect");

	for(;;)
	{
		self waittill("spawned_player");

		// Setup Player Ammo
		self.mine_ammo = getWeaponBasedMineCount(self.pers["weapon"]);

		self.defusing = 0;
		self thread Mine_Warning_Monitor();
		self thread Mine_Plant_Monitor();
	}
}

Mine_Warning_Monitor()
{
	self endon("disconnect");
	self endon("killed_player");

	while(1)
	{
		wait 0.1;

		mine_warn = 0;
		def_warn = 0;
		mines = getentarray("item_mine", "targetname");
		for(i = 0; i < mines.size; i++)
		{             
			mine = mines[i];

			dist = 1000;
			if (isDefined(mine.origin))
				dist = int(distance(self.origin,mine.origin));
			
			if (dist < level.mine_warn_distance)
			{
				if (level.gametype == "dm" && mine.owner != self)
					mine_warn = 1;
				else if (level.gametype != "dm" && mine.team != self.pers["team"])
					mine_warn = 1;
			}

			if (dist < level.mine_defuse_distance)
			{
				if (level.gametype == "dm" && mine.owner != self && self GetStance(false) > 0)
					def_warn = 1;
				else if (level.gametype != "dm" && mine.team != self.pers["team"] && self GetStance(false) > 0)
					def_warn = 1;
			}
		}

		if (mine_warn && level.allow_warning && !isDefined(self.mine_hud_warn) )
		{
			// DO HUD for mine warning
			self.mine_hud_warn =  newClientHudElem(self);
			self.mine_hud_warn.x = 0;
			self.mine_hud_warn.y = 125;
			self.mine_hud_warn.alignX = "center";
			self.mine_hud_warn.alignY = "middle";
			self.mine_hud_warn.horzAlign= "center_safearea";
			self.mine_hud_warn.vertAlign = "center_safearea";
			self.mine_hud_warn.fontScale = 1;
			self.mine_hud_warn.color = (1,0,0);
			self.mine_hud_warn.alpha = 1;
			self.mine_hud_warn setText(game["mine_warn"]);
		}
		else if (!mine_warn && isDefined(self.mine_hud_warn))
			self.mine_hud_warn destroy();

		if (def_warn && !isDefined(self.mine_hud_def_warn))
		{
			// DO HUD for defuse warning
			self.mine_hud_def_warn =  newClientHudElem(self);
			self.mine_hud_def_warn.x = 0;
			self.mine_hud_def_warn.y = 90;
			self.mine_hud_def_warn.alignX = "center";
			self.mine_hud_def_warn.alignY = "middle";
			self.mine_hud_def_warn.horzAlign= "center_safearea";
			self.mine_hud_def_warn.vertAlign = "center_safearea";
			self.mine_hud_def_warn.fontScale = 1;
			self.mine_hud_def_warn.color = (0.580,0.961,0.573);
			self.mine_hud_def_warn.alpha = 1;
			self.mine_hud_def_warn setText(game["mine_defuse"]);
		}
		else if (!def_warn && isDefined(self.mine_hud_def_warn))
			self.mine_hud_def_warn destroy();
	}
}

Mine_Plant_Monitor()
{
	self endon("disconnect");
	self endon("killed_player");

	if (!self.mine_ammo)
		return;

	if (!isDefined(self.mine_hud_ammo))
	{
		//HUD AMMO Display
		self.mine_hud_ammo = newClientHudElem(self);
		self.mine_hud_ammo.horzAlign = "center";
		self.mine_hud_ammo.vertAlign = "middle";
		self.mine_hud_ammo.horzAlign= "center_safearea";
		self.mine_hud_ammo.vertAlign = "center_safearea";
		self.mine_hud_ammo.alpha = 1;
		self.mine_hud_ammo.x = 245;
		self.mine_hud_ammo.y = 78;
		self.mine_hud_ammo setShader(game["mine_hud_ammo"], 29, 37); //29,21

		//Ammo Text
		self.mine_hud_ammotxt = newClientHudElem(self);
		self.mine_hud_ammotxt.horzAlign = "center";
		self.mine_hud_ammotxt.vertAlign = "middle";
		self.mine_hud_ammotxt.horzAlign= "center_safearea";
		self.mine_hud_ammotxt.vertAlign = "center_safearea";
		self.mine_hud_ammotxt.alpha = .94;
		self.mine_hud_ammotxt.fontScale = 1.2;
		self.mine_hud_ammotxt.x = 269;
		self.mine_hud_ammotxt.y = 93;
		self.mine_hud_ammotxt setText(game["mine_txt"]); 
	}

	wait 0.5;

	while (self.mine_ammo)
	{
		timer = 0;
		while (self GetStance(false) > 1 && self useButtonPressed() == true)
		{
			//prevent plant from occuring right after defuse/bomb interraction
			if (self.defusing || isdefined(self.progressbackground))
			{
				while (self useButtonPressed() == true)
				{
					wait .5;
				}
				break;
			}
			//Mine Plant Hysterisous
			if (timer < .5)
			{
				timer = timer + .05;
				wait .05;
				continue;
			}

			if (self Too_Close_To_Spawnpoints())
				break;

			if(!isdefined(self.mine_plant_txt))
			{
				self.mine_plant_txt = newClientHudElem(self);
				self.mine_plant_txt.x = 0;
				self.mine_plant_txt.y = 90;
				self.mine_plant_txt.alignX = "center";
				self.mine_plant_txt.alignY = "middle";
				self.mine_plant_txt.horzAlign = "center_safearea";
				self.mine_plant_txt.vertAlign = "center_safearea";
				self.mine_plant_txt.fontScale = 1;
				self.mine_plant_txt.color = (0.580,0.961,0.573);
				self.mine_plant_txt.alpha = 1;
				self.mine_plant_txt setText(game["mine_plant_txt"]);
			}

			if(!isdefined(self.mine_plant_progressbackground))
			{
				self.mine_plant_progressbackground = newClientHudElem(self);
				self.mine_plant_progressbackground.x = 0;
				self.mine_plant_progressbackground.y = 104;
				self.mine_plant_progressbackground.alignX = "center";
				self.mine_plant_progressbackground.alignY = "middle";
				self.mine_plant_progressbackground.horzAlign = "center_safearea";
				self.mine_plant_progressbackground.vertAlign = "center_safearea";
				self.mine_plant_progressbackground.alpha = 0.5;
			}
			self.mine_plant_progressbackground setShader("black", (level.mine_barsize + 4), 12);

			if(!isdefined(self.mine_plant_progressbar))
			{
				self.mine_plant_progressbar = newClientHudElem(self);
				self.mine_plant_progressbar.x = int(level.mine_barsize / (-2.0));
				self.mine_plant_progressbar.y = 104;
				self.mine_plant_progressbar.alignX = "left";
				self.mine_plant_progressbar.alignY = "middle";
				self.mine_plant_progressbar.horzAlign = "center_safearea";
				self.mine_plant_progressbar.vertAlign = "center_safearea";
			}
			self.mine_plant_progressbar setShader("white", 0, 8);
			self.mine_plant_progressbar scaleOverTime(level.mine_planttime, level.mine_barsize, 8);

			self playsound("moody_plant");
			self.mine_plant_sitstill = spawn("script_origin", self.origin);
			self linkTo(self.mine_plant_sitstill);
			self disableWeapon();

			progresstime = 0;
			while(isAlive(self) && self useButtonPressed() && progresstime < level.mine_planttime && self GetStance(false) == 2)
			{
				progresstime += 0.05;
				wait 0.05;
			}

			if(progresstime >= level.mine_planttime)
			{
				self.mine_plant_progressbackground destroy();
				self.mine_plant_progressbar destroy();
				self.mine_plant_txt destroy();
				self unlink();
				self enableWeapon();

				if (isDefined(self.mine_plant_sitstill))
					self.mine_plant_sitstill delete();

				self iprintln(&"AA_MI_MINA_05");
				self.mine_ammo = self.mine_ammo - 1;

				self thread Drop_Landmine();
			}
			else
			{
				if(isdefined(self.mine_plant_progressbackground))
					self.mine_plant_progressbackground destroy();

				if(isdefined(self.mine_plant_progressbar))
					self.mine_plant_progressbar destroy();

				if(isdefined(self.mine_plant_txt))
					self.mine_plant_txt destroy();

				self unlink();
				self enableWeapon();
				if (isDefined(self.mine_plant_sitstill))
					self.mine_plant_sitstill delete();
			}

			if (!self.mine_ammo)
				break;

			timer = 0;
			wait .05;
		}

		
		wait .1;
	}

	// Destroy HUD Ammo Display
	if (isDefined(self.mine_hud_ammo))
		self.mine_hud_ammo destroy();

	if (isDefined(self.mine_hud_ammotxt))
		self.mine_hud_ammotxt destroy();
}

Drop_Landmine()
{
	if (!isDefined(self))
		return;

	team = "both";
	if (isDefined(self.pers["team"]))
		team = self.pers["team"];

	plant = self getPlant();
	
    if(isDefined(game["landmines"][game["currentmine"]]))
		game["landmines"][game["currentmine"]] delete();
     
	item_mine = spawn( "script_model", plant.origin - (0,0,0) ); //(0,0,level.mine_difficulty) );
	item_mine setModel(game["mine_model"]);
	item_mine.targetname = "item_mine";
	item_mine hide();
	item_mine.owner = self;
	item_mine.angles = plant.angles + (0, 0, 90);
	item_mine.team = team;
	item_mine.identifier = game["currentmine"];
	item_mine.being_defused = 0;
	item_mine show(); 

	item_mine thread Mine_Think();
	item_mine thread Mine_Defuse_Think();
	
    game["landmines"][game["currentmine"]] = item_mine;
    game["currentmine"]++;

	if(game["currentmine"] >= level.landmined_limit)
		game["currentmine"] = 0;

	//Play Sound
	self playsound("weap_fraggrenade_pin");
	wait .15;
	self playsound("weap_fraggrenade_pin");
}

Mine_Think()
{
	self endon("kill_mine_think");

	while(1)
	{
		wait 0.2;
		
		if(!isDefined(self))
			return;
		
		players = getentarray("player", "classname");
		for(i = 0; i < players.size; i++)
		{             

			player = players[i];

			//Make sure this player is elligible to trip the mine
			if (level.gametype == "dm")
			{
				if (isDefined(self.owner) && player == self.owner)
					continue;
			}
			else if (player.pers["team"] == self.team)
				continue;

			if(player.sessionstate != "playing")
				continue;
 
			//Too Close! Explosion!
			if( distance(self.origin,player.origin) < level.mine_trip_distance )
			{
				self notify("kill_mine_defuse_think");

				// Click so they know thier dead!
				self playsound ("minefield_click");
				wait 0.75;

				//Do Explosion
				self playsound("explo_mine");
				playfx(level.mine_explosion_effect, self.origin);

				//Do Damage
				if (isDefined(self.owner) && isPlayer(self.owner))
					thread Do_Damage(self.origin, self.team, self.owner);
				else
					thread Do_Damage(self.origin, self.team);

				if(isDefined(self)) 
					self delete();
				
				return;
			}
		}				
	}
}

Mine_Defuse_Think()
{
	self endon("kill_mine_defuse_think");

	while(1)
	{
		wait 0.2;
		
		if(!isDefined(self))
			return;
		
		players = getentarray("player", "classname");
		for(i = 0; i < players.size; i++)
		{

			player = players[i];

			//Make sure this player is elligible to defuse the mine
			if (level.gametype == "dm")
			{
				if (isDefined(self.owner) && player == self.owner)
					continue;
			}
			else if (player.pers["team"] == self.team)
				continue;

			if(player.sessionstate != "playing")
				continue;

			stance = player GetStance(true);
			if (stance < 1 || stance > 2)
				continue;

			//Defuse Distance
			while( isDefined(self) && isDefined(player) && isAlive(player) && distance(self.origin,player.origin) < level.mine_defuse_distance && player useButtonPressed() == true && player GetStance(true) > 0)
			{
				self.being_defused = 1;
				player.defusing = 1;

				if(!isdefined(player.mine_progressbackground))
				{
					player.mine_progressbackground = newClientHudElem(player);
					player.mine_progressbackground.x = 0;
					player.mine_progressbackground.y = 104;

					player.mine_progressbackground.alignX = "center";
					player.mine_progressbackground.alignY = "middle";
					player.mine_progressbackground.horzAlign= "center_safearea";
					player.mine_progressbackground.vertAlign = "center_safearea";
					player.mine_progressbackground.alpha = 0.5;
				}
				player.mine_progressbackground setShader("black", (level.mine_barsize + 4), 12);

				if(!isdefined(player.mine_progressbar))
				{
					player.mine_progressbar = newClientHudElem(player);
					player.mine_progressbar.x = int(level.mine_barsize / (-2.0));
					player.mine_progressbar.y = 104;

					player.mine_progressbar.alignX = "left";
					player.mine_progressbar.alignY = "middle";
					player.mine_progressbar.horzAlign = "center_safearea";
					player.mine_progressbar.vertAlign = "center_safearea";
				}
				player.mine_progressbar setShader("white", 0, 8);
				player.mine_progressbar scaleOverTime(level.mine_defusetime, level.mine_barsize, 8);

				//player playsound("MP_bomb_defuse");
				player playsound("moody_plant");
				player linkTo(self);
				player disableWeapon();

				self.progresstime = 0;
				while(isDefined(self) && isAlive(player) && player useButtonPressed() && self.progresstime < level.mine_defusetime && player GetStance(false) > 0)
				{
					self.progresstime += 0.05;
					wait 0.05;
				}
				
				if(self.progresstime >= level.mine_defusetime)
				{
					player.mine_progressbackground destroy();
					player.mine_progressbar destroy();

					self notify("kill_mine_think");
					self delete();

					if (!player.mine_ammo)
					{
						player.mine_ammo++;
						player thread Mine_Plant_Monitor();
					}
				}
				else
				{
					self.being_defused = 0;

					if(isdefined(player.mine_progressbackground))
						player.mine_progressbackground destroy();

					if(isdefined(player.mine_progressbar))
						player.mine_progressbar destroy();
				}

				player unlink();
				player enableWeapon();
				player.defusing = 0;

				wait 0.05;

				if(!isDefined(self))
					return;
			}

			if(!isDefined(self))
					return;
		}
	}
}

GetStance(jumpcheck)
{
	stance = self maps\mp\gametypes\_utils::GetStance(jumpcheck);
	return stance;
}

getWeaponBasedMineCount(weapon)
{
	switch (level.weapons[weapon].classname)
	{
	case "sniper":
		return level.snipermines;
	case "boltaction":
		return level.boltactionmines;
	case "semiautomatic":
		return level.semiautomines;
	case "smg":
		return level.smgmines;
	case "mg":
		return level.mgmines;
	case "shotgun":
		return level.shotgunmines;
	default:
		return 0;
	}
}

getPlant()
{
	start = self.origin + (0, 0, 10);

	range = 32;
	forward = anglesToForward(self.angles);
	forward = maps\mp\_utility::vectorScale(forward, range);

	traceorigins[0] = start + forward;
	traceorigins[1] = start;

	trace = bulletTrace(traceorigins[0], (traceorigins[0] + (0, 0, -18)), false, undefined);
	if(trace["fraction"] < 1)
	{
		temp = spawnstruct();
		temp.origin = trace["position"];
		temp.angles = orientToNormal(trace["normal"]);
		return temp;
	}

	trace = bulletTrace(traceorigins[1], (traceorigins[1] + (0, 0, -18)), false, undefined);
	if(trace["fraction"] < 1)
	{
		temp = spawnstruct();
		temp.origin = trace["position"];
		temp.angles = orientToNormal(trace["normal"]);
		return temp;
	}

	traceorigins[2] = start + (16, 16, 0);
	traceorigins[3] = start + (16, -16, 0);
	traceorigins[4] = start + (-16, -16, 0);
	traceorigins[5] = start + (-16, 16, 0);

	besttracefraction = undefined;
	besttraceposition = undefined;
	for(i = 0; i < traceorigins.size; i++)
	{
		trace = bulletTrace(traceorigins[i], (traceorigins[i] + (0, 0, -1000)), false, undefined);

		if(!isdefined(besttracefraction) || (trace["fraction"] < besttracefraction))
		{
			besttracefraction = trace["fraction"];
			besttraceposition = trace["position"];
		}
	}
	
	if(besttracefraction == 1)
		besttraceposition = self.origin;
	
	temp = spawnstruct();
	temp.origin = besttraceposition;
	temp.angles = orientToNormal(trace["normal"]);
	return temp;
}

orientToNormal(normal)
{
	hor_normal = (normal[0], normal[1], 0);
	hor_length = length(hor_normal);

	if(!hor_length)
		return (0, 0, 0);
	
	hor_dir = vectornormalize(hor_normal);
	neg_height = normal[2] * -1;
	tangent = (hor_dir[0] * neg_height, hor_dir[1] * neg_height, hor_length);
	plant_angle = vectortoangles(tangent);

	return plant_angle;
}

Do_Damage(mine_origin, mine_team, setter)
{
	//Setup Explosion
	range = 200;

	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{             

		player = players[i];

		// Do not do friendly damage if friendly damage is off
		if(level.gametype != "dm" && level.friendlyfire == "0" && player.pers["team"] == mine_team)
			continue;

		dist = int(distance(mine_origin,player.origin));
		if ( dist > range)
			continue;

		//Damage Calculation
		damage = int((500/(.018*dist)) - 75);
		if (damage < 5)
			damage = 5;

		//Check to see if the setter is even on the server anymore
		if (!isDefined(setter) || !isPlayer(setter))
			player finishPlayerDamage(undefined, undefined, damage, 0, "MOD_EXPLOSIVE", "mine", undefined, undefined, "none", 0);
		else
			player finishPlayerDamage(setter, setter, damage, 0, "MOD_EXPLOSIVE", "mine", undefined, undefined, "none", 0);
	}
}

Too_Close_To_Spawnpoints()
{
	//Check for Spawnpoints
	spawnpointname = undefined;
	switch (level.gametype)
	{
	case "sd":
		return false;

	case "ctf":
		if (self.pers["team"] == "axis")
			spawnpointname = "mp_ctf_spawn_allied";
		else if (self.pers["team"] == "allies")
			spawnpointname = "mp_ctf_spawn_axis";
		break;
	
	case "dm":
		spawnpointname = "mp_dm_spawn";
		break;
	
	case "tdm":
	case "hq":
	case "htf":
		spawnpointname = "mp_tdm_spawn";
		break;
	}

	//Check distance from all relevant spawnpoints
	if (isDefined(spawnpointname))
	{
		spawnpoints = getentarray(spawnpointname, "classname");

		for (i=0;i<spawnpoints.size;i++)
		{
			spawnpoint = spawnpoints[i];

			if (distance(self.origin,spawnpoint.origin) < 120)
			{
				self iprintln(&"AA_MI_MINA_06");
				return true;
			}
		}
	}

	//Extra check for CTF flag zones
	flag_name = undefined;
	if (level.gametype == "ctf")
	{
		if (self.pers["team"] == "axis")
			flag_name = "axis_flag";
		else if (self.pers["team"] == "allies")
			flag_name = "allied_flag";
	}

	if (isDefined(flag_name))
	{
		flags = getentarray(flag_name, "targetname");

		for (i=0;i<flags.size;i++)
		{
			flag = flags[i];

			if (distance(self.origin,flag.origin) < 150)
			{
				self iprintln(&"AA_MI_MINA_06");
				return true;
			}
		}
	}

	return false;
}