Start_Messagecenter()
{
	// Setup Welcome Center
	thread Setup_WelcomeCenter();
	
	// Continuous Message Center
	if (!getcvarint("mc_enable"))
	{
		game["mc_running"] = 0;
		level notify("mc_restart");
		return;
	}
		 
	if (!isDefined(game["mc_running"]) )
		game["mc_running"] = 0;
		
	if (getCvarint("mc_restarteveryround") )
	{
		game["mc_running"] = 0;
		level notify("mc_restart");
		wait .05;
		Run_Messages();
	}
	else if (game["mc_running"])
		return;
		
	game["mc_running"] = 1;
	Run_Messages();
}

Run_Messages()
{
	level endon("mc_restart");
	
	// Set up Generic timer
	if(getcvar("mc_delay") == "")
		setcvar("mc_delay", "20");
	generic_delay = 20;
		
	//Check to see if max messages is set, if not default to 20
	if (getcvar("mc_maxmessages") == "")
		setcvar("mc_maxmessages" , 20);
	
	while (1)
	{
		// Set up Maximum Messages
		max = getcvarint("mc_maxmessages") +1;
		
		// Run Through Possible Messages
		for (i=1;i<max;i++)
		{
			// No message, continue looking
			if (getcvar("mc_message" + i) == "")
			{
				wait .05;
				continue;
			}
			else
			{
				// Found Message, set it up for display
				message = getcvar("mc_message" + i);
				
				//First check for message specific timer
				if (getcvar("mc_messagedelay" +i) == "")
				{
					// No message specific timer, use generic timer
					if (generic_delay != getcvarint("mc_delay"))
					{
						generic_delay = getcvarint("mc_delay");
						if (generic_delay < 5)
						{
							setcvar("mc_delay" , 5);
							generic_delay = 5;
						}
					}
					
					delay = generic_delay;
				}
				else
				{
					delay = getcvarint("mc_messagedelay" +i);
					if (delay < 0)
						delay = 0;
				}
				
				//Lets see if this is a SPECIAL message
				if (message == "<*nextmap*>")
					message = maps\mp\gametypes\_utils::Get_Next_Map();
				else if (message == "<*gtrules*>")
					message = GameTypeRules();


				if (!isDefined(message))
				{
					wait .05;
					continue;
				}
				
				// Run Timer
				wait delay;
				
				// Display Message
				if (level.logging)
				{
					setcvar("logfile", 0);
					wait .05;

					iprintln(message);
					setcvar("logfile", 1);
				}
				else
					iprintln(message);
			}
		}
		
		loopdelay = getcvarint("mc_delay");
		if (loopdelay < 5)
		{
			setcvar("mc_delay" , 5);
			loopdelay = 5;
		}
		
		wait loopdelay;
	}
}

GameTypeRules()
{
	if (!isdefined(level.gametype) || level.gametype == "")
		return undefined;

	message = getcvar("mc_rules_" + level.gametype);

	if (message == "")
		return undefined;
	else
		return message;
}

Setup_WelcomeCenter()
{
	if (!getcvarint("wc_enable"))
	{
		game["wc_enabled"] = 0;
		return;
	}
			
	//Verify there are welcome center messages
	exists = Verify_Messages();
	if (!exists)
	{
		setcvar("wc_enable", 0);
		//iprintln("^1Welcome Center Disabled: ^3No Welcome Messages");
		game["wc_enabled"] = 0;
		return;
	}
	
	game["wc_enabled"] = 1;
}

Verify_Messages()
{
	exists = false;
	if (getCvar("wc_line1") != "" || getCvar("wc_line2") != "" || getCvar("wc_line3") != "" || getCvar("wc_line4") != "" || getCvar("wc_line5") != "")
		exists = true;
	
	return exists;
}


Welcome_Me()
{
	self endon("disconnect");

	if ( game["forcedownloads"] && !isDefined(self.pers["warned"]) )
		Downloads_Forced_Warning();
	self.pers["warned"] = 1;

	if (!game["wc_enabled"])
		return;

	if (isDefined(self.pers["welcomed"]))
		return;

	self waittill("spawned");

	//while (self.pers["team"] == "spectator" || !isDefined(self.pers["weapon"]))
		wait .5;

	// Do Welcome Messages

	{
		self iprintlnbold(&"AA_RD_M1");
		wait 1;

		self iprintlnbold(&"AA_RD_M2");
		wait 1;

		self iprintlnbold(&"AA_RD_M3");
		wait 1;

		/*self iprintlnbold(&"AA_RD_M12");
		wait 1;

		self iprintlnbold(&"AA_RD_M13");
		wait 1;*/
	}

	self.pers["welcomed"] = 1;
}

Precache_MessageCenter_HUD()
{
	// HUD www element
	if (getcvarint("mc_showsite"))
	{
		game["mc_site"] = &"AA_RD_LOGO"; // CHANGE THIS LINE TO YOUR SITE
		precacheString(game["mc_site"]);

		thread MessageCenterHUD();
	}
}

MessageCenterHUD()
{
	level notify("MC_HUD_RESTART");

	if (isDefined(level.mc_hud))
		level.mc_hud destroy();

	wait .05;

	level endon("MC_HUD_RESTART");

	level.mc_hud = newHudElem();
	level.mc_hud.x = 5;
	level.mc_hud.y = 473; 
	level.mc_hud.alignX = "left";
	level.mc_hud.alignY = "middle";
	level.mc_hud.alpha = 1;
	level.mc_hud.fontScale = .8;
	level.mc_hud.color = (.99, .99, .75);
	level.mc_hud setText(game["mc_site"]);
}

Downloads_Forced_Warning()
{
	self iprintlnbold(&"AA_RD_AUTO_DL");
	self iprintlnbold(&"AA_RD_AUTO_DL2");
	self iprintlnbold(&"AA_RD_AUTO_DL3");

	wait 6;
}