Init()
{
	cooked_nades = false;
	if (getcvar("scr_cookable_nades") != "" && getcvarint("scr_cookable_nades") > 0)
		cooked_nades = true;

	heavy_nades = false;
	if (getcvar("scr_heavy_nades") != "" && getcvarint("scr_heavy_nades") > 0)
		heavy_nades = true;

	//Nade Types:
	//  0 = normal/stock
	//  1 = cookable but normal weight
	//  2 = non-cookable but heavy
	//  3 = cookable and heavy

	level.nade_type = "frag_grenade_";

	if (cooked_nades && !heavy_nades)
		level.nade_type = "frag_type1_";
	else if (!cooked_nades && heavy_nades)
		level.nade_type = "frag_type2_";
	else if (cooked_nades && heavy_nades)
		level.nade_type = "frag_type3_";

	//Smoke Nade Options
	ax_smoke_color = 0;
	if (getcvar("scr_axis_smoke_color") != "" && getcvarint("scr_axis_smoke_color") > 0)
		ax_smoke_color = getcvarint("scr_axis_smoke_color");

	al_smoke_color = 0;
	if (getcvar("scr_allies_smoke_color") != "" && getcvarint("scr_allies_smoke_color") > 0)
		al_smoke_color = getcvarint("scr_allies_smoke_color");

	if (ax_smoke_color == 1)
		level.ax_smoke_type = "smoke_color1_";
	else if (ax_smoke_color == 2)
		level.ax_smoke_type = "smoke_color2_";
	else if (ax_smoke_color == 3)
		level.ax_smoke_type = "smoke_color3_";
	else if (ax_smoke_color == 4)
		level.ax_smoke_type = "smoke_color4_";
	else
		level.ax_smoke_type = "smoke_grenade_";

	if (al_smoke_color == 1)
		level.al_smoke_type = "smoke_color1_";
	else if (al_smoke_color == 2)
		level.al_smoke_type = "smoke_color2_";
	else if (al_smoke_color == 3)
		level.al_smoke_type = "smoke_color3_";
	else if (al_smoke_color == 4)
		level.al_smoke_type = "smoke_color4_";
	else
		level.al_smoke_type = "smoke_grenade_";
}


Precache_Nades()
{
	//Grenades
	allies_nade_name = Get_nadeName("allies");
	precacheItem(allies_nade_name);

	axis_nade_name = Get_nadeName("axis");
	precacheItem(axis_nade_name);

	//Smokes
	allies_smoke_name = Get_smokeName("allies");
	precacheItem(allies_smoke_name);

	axis_smoke_name = Get_smokeName("axis");
	precacheItem(axis_smoke_name);
}


Get_nadeName(team)
{
	nade_name = "frag_grenade_german_mp";

	if(team == "allies")
	{
		switch(game["allies"])
		{
		case "american":
			nade_name = level.nade_type + "american_mp";
			break;

		case "british":
			nade_name = level.nade_type + "british_mp";
			break;

		default:
			nade_name = level.nade_type + "russian_mp";
			break;
		}
	}
	else
	{
		assert(team == "axis");
		nade_name = level.nade_type + "german_mp";
	}

	return nade_name;
}

Get_smokeName(team)
{
	smoke_name = "smoke_grenade_german_mp";

	if(team == "allies")
	{
		switch(game["allies"])
		{
		case "american":
			smoke_name = level.al_smoke_type + "american_mp";
			break;

		case "british":
			smoke_name = level.al_smoke_type + "british_mp";
			break;

		default:
			smoke_name = level.al_smoke_type + "russian_mp";
			break;
		}
	}
	else
	{
		assert(team == "axis");
		smoke_name = level.ax_smoke_type + "german_mp";
	}

	return smoke_name;
}