Do_Obit(sHitLoc, attacker, sWeapon, sMeansOfDeath)
{
	if (level.allow_obituary > 2)
	{
		obituary(self, attacker, sWeapon, sMeansOfDeath);
		self Detailed_Obit(sHitLoc, attacker, sWeapon, sMeansOfDeath);
	}
	else if (level.allow_obituary > 1)
		self Detailed_Obit(sHitLoc, attacker, sWeapon, sMeansOfDeath);
	else
		obituary(self, attacker, sWeapon, sMeansOfDeath);
}


Detailed_Obit(sHitLoc, attacker, sWeapon, sMeansOfDeath)
{
	txt_weapon = getWeaponName(sWeapon, sMeansOfDeath);
	txt_hitLoc = getHitLoc(sHitLoc);
	range = distance(attacker.origin, self.origin);
	//feet = int(range * 0.083333333);
	feet = int(range * 0.0254);		// Range in Metres

	if (txt_weapon == "explosion")
			self iprintln(&"MS_KILL_01");
	else if (txt_weapon == "environment")
			self iprintln(&"MS_KILL_02");
	else if (txt_weapon == "fell")
			self iprintln(&"MS_KILL_03");
	else if(isPlayer(attacker))
	{
		if (txt_weapon == "bash")
			self iprintln(attacker.name+"^7 te ha caneado.");
		else if(txt_hitLoc != "unrecognized" && txt_weapon != "unrecognized")
			self iprintln(attacker.name+"^7 te ha matado con una "+txt_weapon+" a "+feet+" metros en el/la "+txt_hitLoc);
		else if(self != attacker)
			self iprintln("Has muerto por " + attacker.name + "^7.");
		else if( (!isDefined(self.switching_teams) || !self.switching_teams) && !self.bleeding)
			self iprintln(&"MS_KILL_09");
	}
}

getWeaponName(sWeapon, sMeansOfDeath)
{
	// Means of Death first:
	switch(sMeansOfDeath)
	{
		case "MOD_FALLING":
			weapon = "fell";
			break;
		
		case "MOD_EXPLOSIVE":
			weapon = "explosion";
			break;

		case "MOD_TRIGGER_HURT":
			weapon = "environment";
			break;

		case "MOD_MELEE":
			weapon = "bash";
			break;

		default:
			weapon = "unrecognized";
			break;
	}

	if (weapon != "unrecognized")
		return weapon;

	// On to the Weapons
	switch(sWeapon)
	{
		//Standard Weapons
		case "greasegun_mp":
			weapon = "M3 Greasegun";
			break;
		case "bar_mp":
			weapon = "BAR";
			break;
		case "m1carbine_mp":
			weapon = "M1A1 Carbine";
			break;
		case "m1garand_mp":
			weapon = "M1 Garand";
			break;
		case "springfield_mp":
			weapon = "Springfield Sniper";
			break;
		case "thompson_mp":
			weapon = "Thompson";
			break;
		case "sten_mp":
			weapon = "Sten";
			break;
		case "enfield_mp":
			weapon = "Lee Enfield";
			break;
		case "enfield_scope_mp":
			weapon = "Scoped Lee Enfield";
			break;
		case "bren_mp":
			weapon = "Bren";
			break;
		case "PPS42_mp":
			weapon = "PPS42";
			break;
		case "mosin_nagant_mp":
			weapon = "Mosin Nagant";
			break;
		case "SVT40_mp":
			weapon = "Tokarev SVT40";
			break;
		case "mosin_nagant_sniper_mp":
			weapon = "Mosin Nagant Sniper";
			break;
		case "ppsh_mp":
			weapon = "PPSh";
			break;
		case "mp40_mp":
			weapon = "MP40";
			break;
		case "kar98k_mp":
			weapon = "Kar98k";
			break;
		case "g43_mp":
			weapon = "Gewehr 43";
			break;
		case "kar98k_sniper_mp":
			weapon = "Kar98k Sniper";
			break;
		case "mp44_mp":
			weapon = "MP44";
			break;
		case "shotgun_mp":
			weapon = "Shotgun";
			break;
		
		//Pistols
		case "colt_mp":
			weapon = "Colt";
			break;
		case "luger_mp":
			weapon = "Luger";
			break;
		case "tt33_mp":
			weapon = "Tokarev TT-33";
			break;
		case "webley_mp":
			weapon = "Webley MK 4";
			break;
		
		//Turret
		case "mg42_mp":
			weapon = "MG42";
			break;

		//Nades
		case "fraggrenade_mp":
		case "frag_grenade_american_mp":
		case "frag_grenade_british_mp":
		case "frag_grenade_russian_mp":
		case "frag_grenade_german_mp":
			weapon = "Grenade";
			break;
		
		//Smoke Nades (Modded maybe?)
		case "smokegrenade_mp":
		case "smoke_grenade_american_mp":
		case "smoke_grenade_british_mp":
		case "smoke_grenade_russian_mp":
		case "smoke_grenade_german_mp":
			weapon = "Smoke Grenade";
			break;
		

		//Easily modded in weapons:
		case "dp28_mp":
			weapon = "Degtyarev-Pekhotny 28";
			break;
		case "panzerfaust_mp":
			weapon = "Panzerfaust";
			break;
		case "panzerschreck_mp":
			weapon = "Panzerschreck";
			break;
		case "30cal_mp":
			weapon = "30Cal MG";
			break;

		
		//Special Cases to be handled:
		//Bleed
		case "MOD_BLEED":
			weapon = "bleed";
			break;
		
		case "MOD_EXPLOSIVE":
			weapon = "explosion";
			break;

		case "MOD_TRIGGER_HURT":
			weapon = "environment";
			break;

		case "MOD_MELEE":
			weapon = "bash";
			break;

		default:
			weapon = "unrecognized";
			break;
	}
	return weapon;
}

getHitLoc(sHitLoc)
{
	switch(sHitLoc)
	{
	case "torso_upper":
		hitLoc = "pecho";
		break;
	case "torso_lower":
		hitLoc = "estomago";
		break;

	case "helmet":
	case "head":
		hitLoc = "cabeza";
		break;
	case "neck":
		hitLoc = "cuello";
		break;

	case "left_arm_upper":
	case "left_arm_lower":
		hitLoc = "brazo izquierdo";
		break;
	case "right_arm_upper":
	case "right_arm_lower":
		hitLoc = "brazo derecho";
		break;

	case "left_hand":
		hitLoc = "mano izquierda";
		break;
	case "right_hand":
		hitLoc = "mano derecha";
		break;

	case "left_leg_upper":
	case "left_leg_lower":
		hitLoc = "pierna izquierda";
		break;

	case "right_leg_upper":
	case "right_leg_lower":
		hitLoc = "pierna derecha";
		break;

	case "left_foot":
		hitLoc = "pie izquierdo";
		break;
	case "right_foot":
		hitLoc = "pie derecho";
		break;

	case "gun":
		hitLoc = "arma";
		break;
	default:
		hitLoc = "unrecognized";
		break;
	}
	return hitLoc;
}