Init()
{
	if ( getcvarint("scr_random_map_rotation") < 1)
		return;

	if( isDefined(game["random_rotation"]) )
		return;

	game["random_rotation"] = 1;

	// Randomization Depth
	depth = getcvarint("scr_random_map_depth");

	if (depth < 3)
		depth = 3;
	if (depth > 9)
		depth = 9;

	//Get current rotation
	current = getcvar("sv_maprotationcurrent");

	if (current == "")
	{
		current = getcvar("sv_maprotation");
		setcvar("sv_maprotationcurrent", current);
	}

	// Explode entries into an array
	j=0;
	entry[j] = "";	
	for(i=0;i<current.size;i++)
	{
		if(current[i]==" ")
		{
			j++;
			entry[j] = "";
		}
		else
			entry[j] += current[i];
	}
	
	lastmap = "none";
	//Get last map in rot
	for ( i=0;i<entry.size;i++ )
	{
		if (entry[i] == "map")
			lastmap = entry[i] + " " + entry[i+1];
	}

	//Make sure a fast_restart has not happened
	if (getcvar("mapname") == lastmap)
		return;

	n = 0;
	newmaprot[n] = "";
	for ( i=0;i<entry.size;i++ )
	{
		if (entry[i] == "gametype")
		{
			newmaprot[n] = entry[i] + " " + entry[i+1];
			i++;
			continue;
		}

		if (entry[i] == "map")
		{
			newmaprot[n] = newmaprot[n] + entry[i] + " " + entry[i+1];
			i++;
			n++;
			newmaprot[n] = "";
			continue;
		}

		if (n == depth)
			break;
	}

	//Choose Random Map
	if (n < depth)
		depth = n;

	next_rand_map = randomInt(depth);

	new_rotation = newmaprot[next_rand_map];
	line1 = new_rotation;

	//Re-install the non-successful maps to front of rotation
	for ( k=0;k<newmaprot.size;k++ )
	{
		if (k==next_rand_map)
			continue;

		if (newmaprot[k] == "")
			continue;

		new_rotation = new_rotation + " " + newmaprot[k];
	}

	//Re-install non-contender maps
	for (i=i;i<entry.size;i++)
		new_rotation = new_rotation + " " + entry[i];

	//Re-install winner map at end
	new_rotation = new_rotation + " " + newmaprot[next_rand_map];

	setcvar("sv_maprotationcurrent", new_rotation);
}