Spawn_Protection_Init()
{
	if (getcvar("scr_spawnprotection") == "" || getcvarint("scr_spawnprotection") < 1)
		level.spawnprotection = 0;
	else
		level.spawnprotection = getcvarint("scr_spawnprotection");

	if (getcvar("scr_show_protection_icon") == "" || getcvarint("scr_show_protection_icon") < 1)
		level.show_protection_icon = 0;
	else
		level.show_protection_icon = 1;

	level thread onPlayerConnect();
}

Spawn_Protection_PreCache()
{
	// Head Icon
	game["headicon_protected"] = "gfx/hud/hud@health_cross.tga";
	precacheHeadIcon(game["headicon_protected"]);

	// Health Icon for Heal/Spawn Protect
	game["hud_health_cross"] = "gfx/hud/hud@health_cross.tga";
	precacheShader(game["hud_health_cross"]);

	game["hud_text_protected"] = &"Spawn Protection Active";
	precacheString(game["hud_text_protected"]);
}


onPlayerConnect()
{
	for(;;)
	{
		level waittill("connecting", player);

		player.spawnprotected = false;
		player.protectiontime = undefined;

		if (level.spawnprotection)
		{
			player thread onPlayerSpawned();
			player thread onPlayerKilled();
		}
	}
}

onPlayerSpawned()
{
	self endon("disconnect");

	for(;;)
	{
		self waittill("spawned_player");

		if (!self.spawnprotected)
			self thread Start_Protection();
	}
}

onPlayerKilled()
{
	self endon("disconnect");

	for(;;)
	{
		self waittill("killed_player");

		self.spawnprotected = false;

		if (isDefined(self.protected_hud))
			self.protected_hud destroy();
		if (isDefined(self.protected_hudicon))
			self.protected_hudicon destroy();
	}
}

Start_Protection()
{
	self endon("disconnect");

	self.spawnprotected = true;
	self.protectiontime = level.spawnprotection;

	self thread Head_Icon();

	if (isDefined(self.protected_hud))
		self.protected_hud destroy();
	if (isDefined(self.protected_hudicon))
		self.protected_hudicon destroy();

	self.protected_hudicon = newClientHudElem(self);
	self.protected_hudicon.x = 0;
	self.protected_hudicon.y = 195;
	self.protected_hudicon.alignX = "center";
	self.protected_hudicon.alignY = "middle";
	self.protected_hudicon.horzAlign = "center_safearea";
	self.protected_hudicon.vertAlign = "center_safearea";
	self.protected_hudicon.alpha = .9;
	self.protected_hudicon.archived = false;
	self.protected_hudicon setShader(game["hud_health_cross"], 12, 12);

	self.protected_hud = newClientHudElem(self);
	self.protected_hud.x = 0;
	self.protected_hud.y = 180;
	self.protected_hud.alignX = "center";
	self.protected_hud.alignY = "middle";
	self.protected_hud.horzAlign = "center_safearea";
	self.protected_hud.vertAlign = "center_safearea";
	self.protected_hud.alpha = 1;
	self.protected_hud.archived = false;
	self.protected_hud.font = "default";
	self.protected_hud.fontscale = 1;
	self.protected_hud.color = (0.980,0.996,0.388);
	self.protected_hud setText(game["hud_text_protected"]);

	self thread MonitorAttackKey();

	timer = 0;
	while (self.protectiontime)
	{
		if (!self.spawnprotected)
			break;

		wait .1;
		timer++;

		if (timer == 10)
		{
			self.protectiontime--;
			timer = 0;
		}
	}

	self.spawnprotected = false;

	if (isDefined(self.protected_hud))
		self.protected_hud destroy();
	if (isDefined(self.protected_hudicon))
		self.protected_hudicon destroy();
}

MonitorAttackKey()
{
	self endon("disconnect");

	while (self.spawnprotected)
	{
		wait 0.1;

		if (self attackButtonPressed())
			self.spawnprotected = false;
	}
}

Return_Head_Icon()
{
	if(isDefined(self.pers["team"]) && self.pers["team"] != "spectator" && self.sessionstate == "playing")
	{
		if( isDefined(level.drawfriend) && level.drawfriend )
		{
			if(self.pers["team"] == "allies")
			{
				self.headicon = game["headicon_allies"];
				self.headiconteam = "allies";
			}
			else
			{
				self.headicon = game["headicon_axis"];
				self.headiconteam = "axis";
			}
		}
		else
		{
			self.headicon = "";
		}
	}
}

Head_Icon()
{
	self endon("disconnect");

	if (!level.show_protection_icon)
		return;

	if ( isDefined(self.headiconteam) )
		self.headiconteam = "none";
	self.headicon = game["headicon_protected"];

	while (self.protectiontime)
	{
		if (!self.spawnprotected)
			break;

		wait .5;
	}
	
	self Return_Head_Icon();

}