#include maps\mp\_utility;

Init()
{
	if (getcvar("scr_allow_sprint") == "")
		setcvar("scr_allow_sprint", 0);

	if (getcvar("scr_sprint_time") == "")
		setcvar("scr_sprint_time", 3);
	level.sprint_time = int(getcvarfloat("scr_sprint_time") * 250);
	level.sprint_min_stamina = int(getcvarfloat("scr_sprint_time") * 62.5);

	if (getcvar("scr_sprint_regen_time") == "")
		setcvar("scr_sprint_regen_time", 6);
	regentime = getcvarint("scr_sprint_regen_time");
	level.sprint_fast_regen = int(level.sprint_time / (regentime * 20) );
	level.sprint_fast_regen2 = level.sprint_fast_regen * 2;

	level.sprint_slow_regen = int(level.sprint_fast_regen / 2);
	level.sprint_slow_regen2 = level.sprint_slow_regen * 2;

	level.sprint_team_bash = 0;
	if (getcvar("scr_sprint_team_bashing") == "")
		setcvar("scr_sprint_team_bashing", 1);

	if (getcvar("scr_sprint_speed") == "")
		setcvar("scr_sprint_speed", 2);
	level.sprint_weap = "sprint_med_mp";
	if (getcvarint("scr_sprint_speed") == 1)
		level.sprint_weap = "sprint_slow_mp";
	else if (getcvarint("scr_sprint_speed") > 2)
		level.sprint_weap = "sprint_fast_mp";
	
	if ( getcvarint("scr_allow_sprint") != 0  && level.sprint_time > 25)
	{
		if (getcvarint("scr_sprint_team_bashing") > 0)
			level.sprint_team_bash = 1;

		level thread onPlayerConnect();
		level thread Dropped_Potato_Monitor();
	}
}

onPlayerConnect()
{
	for(;;)
	{
		level waittill("connecting", player);

		player thread onPlayerSpawned();
		player thread onPlayerKilled();
	}
}

onPlayerKilled()
{
	self endon("disconnect");

	for(;;)
	{
		self waittill("killed_player");

		self notify("kill_monitors");

	}
}

onPlayerSpawned()
{
	self endon("disconnect");

	for(;;)
	{
		self waittill("spawned_player");

		self.is_Sprinting = false;
		self.sprint_stamina = level.sprint_time;
		self.old_position = self.origin;

		self thread Monitor_Sprint();
	}
}

Monitor_Sprint()
{
	self endon("disconnect");
	self endon("kill_monitors");

	while (1)
	{
		wait .05;
		delay = 0;

		while ( self useButtonPressed() && self.sprint_stamina > level.sprint_min_stamina)
		{
			wait .1;

			if ( !isMoving(self) || isHoldingNade(self) )
			{
				self.sprint_stamina = self.sprint_stamina + level.sprint_fast_regen2;
				if (self.sprint_stamina > level.sprint_time)
					self.sprint_stamina = level.sprint_time;
				break;
			}

			if (delay < 5)
			{
				self.sprint_stamina = self.sprint_stamina + level.sprint_slow_regen2;
				if (self.sprint_stamina > level.sprint_time)
					self.sprint_stamina = level.sprint_time;
				delay++;
				continue;
			}

			self Sprint();
		}

		if (self.sprint_stamina == level.sprint_time)
			continue;

		if ( isMoving(self) )
			self.sprint_stamina = self.sprint_stamina + level.sprint_slow_regen;
		else
			self.sprint_stamina = self.sprint_stamina + level.sprint_fast_regen;

		if (self.sprint_stamina > level.sprint_time)
			self.sprint_stamina = level.sprint_time;
	}
}

isMoving(player)
{
	moving = true;

	if (player.old_position == player.origin)
		moving = false;
	
	player.old_position = player.origin;

	return moving;
}

isHoldingNade(player)
{
	weapon = player getCurrentWeapon();
	
	switch(weapon)
	{
	case "frag_grenade_american_mp":
	case "smoke_grenade_american_mp":
	case "frag_grenade_british_mp":
	case "smoke_grenade_british_mp":
	case "frag_grenade_russian_mp":
	case "smoke_grenade_russian_mp":
	case "frag_grenade_german_mp":
	case "smoke_grenade_german_mp":
		return true;

	default:
		return false;
	}
}

Sprint()
{
	self endon("disconnect");
	self notify("start_sprinting");

	// 1st get and store current weapon info
	self.sprint_weap_return = self getCurrentWeapon();
	if (self getWeaponSlotWeapon("primary") == self.sprint_weap_return)
		self.sprint_slot = "primary";
	else
		self.sprint_slot = "primaryb";

	self.sprint_weap_ammo_return = self getWeaponSlotAmmo(self.sprint_slot);
	self.sprint_weap_clip_return = self getWeaponSlotClipAmmo(self.sprint_slot);

	self.is_Sprinting = true;

	self setWeaponSlotWeapon(self.sprint_slot, level.sprint_weap);

	sprint_ammo = int( (self.sprint_stamina / level.sprint_time) * 100 );
	self setWeaponSlotAmmo(self.sprint_slot, sprint_ammo);
	self switchToWeapon(level.sprint_weap);

	while ( isAlive(self) && self useButtonPressed() && self.sprint_stamina > 0 )
	{
		wait .1;

		if( !isMoving(self) )
			break;

		self.sprint_stamina = self.sprint_stamina - 25;
		if (self.sprint_stamina < 0)
			self.sprint_stamina = 0;

		sprint_ammo = int( (self.sprint_stamina / level.sprint_time) * 100 );
		self setWeaponSlotAmmo(self.sprint_slot, sprint_ammo);
	}

	//Stoped Sprinting for whatever reason, return old weapon (if Alive!)
	if ( isAlive(self) )
	{
		self setWeaponSlotWeapon(self.sprint_slot, self.sprint_weap_return);
		self setWeaponSlotAmmo(self.sprint_slot, self.sprint_weap_ammo_return);
		self setWeaponSlotClipAmmo(self.sprint_slot, self.sprint_weap_clip_return);
		self switchToWeapon(self.sprint_weap_return);

		self.is_Sprinting = false;

		self thread Sprint_Breathing();
	}
	else
	{
		if (level.allow_weapon_drops)
			self dropItem(self.sprint_weap_return);
	}
}

Sprint_Breathing()
{
	self endon("disconnect");
	self endon("kill_monitors");
	self endon("start_sprinting");

	very_tired = level.sprint_min_stamina * .75;
	getting_better = level.sprint_min_stamina * 2.25;
	minimum_sound = level.sprint_time * .75;
	played_sound = false;

	while (self.sprint_stamina < very_tired && isAlive(self) )
	{
		self playsound("ps_breathing_tired_exit1");
		wait .8;
	}

	while (self.sprint_stamina < getting_better && isAlive(self) )
	{
		self playsound("ps_breathing_tired_exit1");
		wait 1.2;
		played_sound = true;
	}

	if ( played_sound && self.sprint_stamina < minimum_sound && isAlive(self) )
		self playsound("ps_breathing_tired_exit2");
}

Dropped_Potato_Monitor()
{
	while (1)
	{
		wait .1;
		deletePlacedEntity("weapon_" + level.sprint_weap);
	}
}