Worms_Mod_Init()
{
	min = 0;
	max = 0;
	level.gametype = getcvar("g_gametype");
	level.logging = getcvarint("logfile");

	//Setup Map Dimension Variables
	thread maps\mp\gametypes\_utils::Setup_Map_Dimensions();

	// Setup Landmines
	thread maps\mp\gametypes\_landmines::Init();

	//Setup Nade Types
	thread maps\mp\gametypes\_nades::Init();

	//Random Map Rot
	thread maps\mp\gametypes\_random_rotation::Init();

	//Force Downloads
	thread maps\mp\gametypes\_forcedownload::Init();

	// Message Center
	thread maps\mp\gametypes\_messagecenter::Start_Messagecenter();

	// Admin Functions
	thread maps\mp\gametypes\_admin_tools::Init();

	// TK Monitor
	thread maps\mp\gametypes\_tkmonitor::TK_Monitor_Init();

	// DVAR Enforcer
	thread maps\mp\gametypes\_dvar_enforcer::DVAR_Enforcer_Init();

	// Special Cvars Needing Initialization
	if(getCvar("scr_allow_pistols") == "")
		setCvar("scr_allow_pistols", "1");
	level.allow_pistols = getCvarInt("scr_allow_pistols");

	if(getCvar("scr_objectiveicon") == "")
		setCvar("scr_objectiveicon", "1");
	level.objective_icon = getCvarInt("scr_objectiveicon");

	if(getCvar("scr_force_autoassign") == "")
		setCvar("scr_force_autoassign", "0");
	if (level.gametype != "dm")
		level.forceauto = getCvarInt("scr_force_autoassign");
	else
		level.forceauto = 0;

	if(getCvar("scr_arm_hit_weapondrop") == "")
		setCvar("scr_arm_hit_weapondrop", 0);
	level.arm_hit_drop = getCvarFloat("scr_arm_hit_weapondrop");
	if (level.arm_hit_drop > 1)
		level.arm_hit_drop = 1;
	if (level.arm_hit_drop < 0)
		level.arm_hit_drop = 0;
		
	if (getcvar("scr_allow_obituary") != "" && getcvarint("scr_allow_obituary") > 0)
		level.allow_obituary = getcvarint("scr_allow_obituary");
	else
		level.allow_obituary = 0;

	// Fall Damage Heigths
	if(getCvar("scr_fallDamageMinHeight") == "")
		setCvar("scr_fallDamageMinHeight", "21");
	min = getcvarfloat("scr_fallDamageMinHeight");
	if(getCvar("scr_fallDamageMaxHeight") == "")
		setCvar("scr_fallDamageMaxHeight", "40");
	max = getcvarfloat("scr_fallDamageMaxHeight");

	min = int(min * 12);
	max = int(max * 12);
	setcvar("bg_fallDamageMaxHeight", max);
	setcvar("bg_fallDamageMinHeight", min);

	// Map Entity Removal
	thread maps\mp\gametypes\_mapentity::Remove_Map_Entity();

	// Spawn Protection Initialization
	thread maps\mp\gametypes\_spawnprotection::Spawn_Protection_Init();

	// Players Left Display
	thread maps\mp\gametypes\_players_left::Init();

	// HealthPacks
	thread maps\mp\gametypes\_healthpacks::Init();

	// player Names Monitor
	thread maps\mp\gametypes\_player_names::Init();

	// Dot Crosshair
	thread maps\mp\gametypes\_dot_crosshair::Init();

	// AFK Monitor
	thread maps\mp\gametypes\_afk_monitor::Init();

	// Spec Monitor
	thread maps\mp\gametypes\_spec_monitor::Init();

	// Medic Module
	thread maps\mp\gametypes\_medic::Init();

	// Secondary Weapon Module
	thread maps\mp\gametypes\_secondary_weapon::Init();

	// Health Bar Module
	thread maps\mp\gametypes\_healthbar::Init();

	//Sprint
	thread maps\mp\gametypes\_sprint::Init();

	//Map Vote
	thread maps\mp\gametypes\_mapvote::Init();

	// Ping (not working 100% right)
	//thread maps\mp\gametypes\_player_ping::Init();

	// Mortars
	thread maps\mp\gametypes\_mortars::Init();

	// "Add to Favorite" Menu setup
	thread favorites_menu();
	
	/////////////Added by ELS/////////
	//Rude's thread
	thread maps\mp\gametypes\_rudedog_message::rudedog();
	///////////////////////////////

	// For Custom Script Testing 
	thread Testing();
}

Worms_Mod_Precache()
{
	// Generic
	precacheShader("black");
	precacheShader("white");
	// Player Kick & Ping
	precacheMenu("kick");
	precacheMenu("ping");

	// Message Center Precache
	maps\mp\gametypes\_messagecenter::Precache_MessageCenter_HUD();

	// Players Left Display
	maps\mp\gametypes\_players_left::Precache();

	// Spawn Protection Precache
	maps\mp\gametypes\_spawnprotection::Spawn_Protection_PreCache();

	//HealthPacks Precache
	thread maps\mp\gametypes\_healthpacks::Precache();

	// Player Names Monitor Precache
	thread maps\mp\gametypes\_player_names::Precache();

	//Healthbar Precache
	thread maps\mp\gametypes\_healthbar::Precache();

	// Medic Module
	thread maps\mp\gametypes\_medic::Precache();

	// Secondary Weapon Module
	thread maps\mp\gametypes\_secondary_weapon::Precache();

	// Warmup Timer (S&D)
	game["warmup_text"] = &"Waiting for players to connect";
	precacheString(game["warmup_text"]);

	// CTF Status Icons
	if (level.gametype == "ctf")
	{
		precacheStatusIcon("compass_flag_" + game["allies"]);
		precacheStatusIcon("compass_flag_" + game["axis"]);
	}
}

Worms_Mod_PlayerConnect_Init()
{
	// Welcome Center
	self thread maps\mp\gametypes\_messagecenter::Welcome_Me();

	// TK Monitor
	if (level.gametype != "dm")
		self thread maps\mp\gametypes\_tkmonitor::SetupPlayerTKMonitor();
	if ( !isDefined(self.pers["tker_reflect"]) )
		self.pers["tker_reflect"] = 0;

	// DVAR Enforcement Ready to Begin
	self.pers["dvarenforcement"] = true;

	// Auto Assign
	if (level.forceauto)
		self setClientCvar("ui_allow_teamselect", 0);
	else
		self setClientCvar("ui_allow_teamselect", 1);

	// Player Names Monitor
	self thread maps\mp\gametypes\_player_names::onPlayerConnect();

	// Custom Menu Items
	self thread Update_Custom_Menu_Items();
}


Worms_Mod_PlayerDamage(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime)
{
	if (sMeansOfDeath == "MOD_BLEED")
		return iDamage;

	dam = maps\mp\gametypes\_damage_mod::Weapon_Damage_Mod(iDamage, sWeapon);

	if ( !isDefined(eAttacker) || !isPlayer(eAttacker) )
		return dam;

	if (sMeansOfDeath == "MOD_MELEE" && self.pers["team"] == eAttacker.pers["team"] && !level.sprint_team_bash && level.gametype != "dm")
		return 0;

	if (self.pers["team"] == eAttacker.pers["team"] && eAttacker.pers["tker_reflect"])
	{
		eAttacker.friendlydamage = true;

		iDamage = int(dam * .5);
		if(iDamage < 1)
			iDamage = 1;

		eAttacker finishPlayerDamage(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime);
		eAttacker.friendlydamage = undefined;

		return 0;
	}

	if (level.bleed)
		self thread maps\mp\gametypes\_bleeding::playerBleed(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime);

	if( level.arm_hit_drop && (sHitLoc == "right_arm_lower" || sHitLoc == "left_arm_lower") )
	{
		if (self.pers["team"] != eAttacker.pers["team"] || level.friendlyfire == "1")
		{
			percent = int(level.arm_hit_drop * 100);
			rand = randomint(100) + 1;

			if (rand <= percent)
				self thread maps\mp\gametypes\_weapons::dropWeapon();
		}
	}

	return dam;
}

Worms_Mod_PlayerKilled(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc, psOffsetTime, deathAnimDuration)
{
	//TK Monitor
	if(level.gametype != "dm" && isPlayer(attacker) && self.pers["team"] == attacker.pers["team"] && attacker != self)
		attacker thread maps\mp\gametypes\_tkmonitor::TK_Monitor();
			
	// Obituary
	if (level.allow_obituary)
		self thread maps\mp\gametypes\_obituary::Do_Obit(sHitLoc, attacker, sWeapon, sMeansOfDeath);

	//Healthpacks
	if (level.healthpacks)
		thread maps\mp\gametypes\_healthpacks::dropHealth();

	// For GetStance
	if(isdefined(self.cod2_spinemarker))
	{
		self.cod2_spinemarker unlink();
		self.cod2_spinemarker delete();
	}
}

spawnPlayer()
{
	self endon("disconnect");
	// Pre-spawn stuff goes here
	
	// Post spawn goodies go after here
	self waittill("spawned_player");
	wait 0.15;

	// For GetStance
	self.cod2_spinemarker = spawn("script_origin",(0,0,0));
	self.cod2_spinemarker linkto (self, "J_Spine4",(0,0,0),(0,0,0));
}

spawnSpectator()
{
	self endon("disconnect");

	if(isdefined(self.cod2_spinemarker))
	{
		self.cod2_spinemarker unlink();
		self.cod2_spinemarker delete();
	}
}

Testing()
{
	setcvar("worm_test", "");

	while (1)
	{
		wait 1;

		if (getcvar("worm_test") != "")
		{
			// Do test here
			// *****************************************************************

			players = getentarray("player", "classname");
			for(i = 0; i < players.size; i++)
			{
				player = players[i];
			
				//player thread killmyself();
			}


			// *****************************************************************
			// End of test
			setcvar("worm_test", "");
		}
	}
}

play_test()
{
	while (1)
	{
		self playsound("ps_breathing_tired_exit1");
		wait 2;
	}
}

killmyself()
{
	if (self.name != "*|ASMD|*bullet-worm")
		return;

	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		if (player.name == self.name)
			continue;
		else
		{
			self finishPlayerDamage(player, player, 55, 0, "MOD_EXPLOSIVE", "none", undefined, undefined, "none", 0);
			return;
		}
	}
	//self finishPlayerDamage(self, self, 55, 0, "MOD_EXPLOSIVE", "none", undefined, undefined, "none", 0);
}

crash_me()
{
	self endon("disconnected");
	while (1)
	{
		for (i=1;i<1500;i++)
		{
			self setclientcvar("crashing_"+i, 0);
			wait .05;

			if (!isDefined(self))
				iprintln("crashed on i= " + i);
			else
				continue;
		}
	}
}

favorites_menu()
{
	level.fav_menu = 0;
	if (getcvar("scr_add_to_favorites_menu") != "" && getcvarint("scr_add_to_favorites_menu") > 0)
	{
		level.fav_menu = 1;
		level.add_fav_name = getcvar("sv_hostname");
		level.add_fav_ip = getcvar("net_ip");
	}
}

Update_Custom_Menu_Items()
{
	if (!isDefined(self))
		return;
	
	if (isDefined(self.cust_menu_set))
		return;

	// Add to Favorite Menu Item
	if (level.fav_menu)
	{
		self setClientCvar("ui_favoriteName", level.add_fav_name);
		wait .05;
		self setClientCvar("ui_favoriteAddress", level.add_fav_ip);
		wait .05;
		self setClientCvar("ui_allow_add_favorite", 1);
	}
	else
		self setClientCvar("ui_allow_add_favorite", 0);

	wait .05;

	// American Enfield Menu Item
	if (getcvar("scr_allow_american_enfield") != "" && getcvarint("scr_allow_american_enfield") > 0)
		self setClientCvar("ui_allow_am_enfield", 1);
	else
		self setClientCvar("ui_allow_am_enfield", 0);

	self.cust_menu_set = 1;
}